'(
      Radio FM cu afisaj VFD - Copyright YO6PIR(2020)

      Data Procesor  - Atmega88
      VFD Controller - PT6302
      Oscilator intern 8Mhz
      Radio Processor = TEA5760 Phillips
      Radio Data System emulate in software
      Ceas RTC cu ICL1208 sau DS1307 si baterie backup 3V
      Volume Control cu IC-TPL0401A-10 din taste <UP><DWN>
      Cautare automata cu tastele <LEFT><RIGHT> soft "MUTE"
      Cautare manuala cu tastele <LEFT><RIGHT> apasate din nou
      Ceas afisat in mod StandBy pe digiti central
      Buton SatndBy cu LED bi-color <verde-rosu>

*******************************************************
')
$Regfile = "m88adef.dat"
$Crystal = 8000000
$hwstack = 40
$swstack = 16
$framesize = 32
Config Submode = NEW

Const ON = 1
Const OFF = 0
Const Tea5767w = &HC0                                       'Address TEA5767
Const Tea5767r = &HC1
'(
Ceas RTC DS1307
      Const I2Cwrite = &HD0                                 'Adresa DS1307 Write
      Const I2Cread = &HD1                                  'Adresa DS1307 Read
')
'Ceas RTC ISL1208
Const I2Cwrite = &HDE                                       'Adresa ISL1208 Write
Const I2Cread = &HDF                                        'Adresa ISL1208 Read

Const I2Cvolumew = &B01011100                               'Adresa TPL0401 write
Const I2Cvolumer = &B01011101                               'Adresa TPL0401 read

ddrb.0 = 1 : Strobe alias portb.0
ddrb.6 = 1 : DataPin alias portb.7
ddrb.7 = 1 : ClockPin alias portb.6
ddrc.4 = 1 : LedV Alias Portc.4 : Reset LedV
ddrc.5 = 1 : LedR Alias Portc.5 : Reset LedR
DDRB.2 = 1 : SW ALIAS PORTB.2

Config Scl = PortD.1                                        'Config Serial Clock
Config Sda = PortD.0                                        'Config Serial Data
I2Cinit

'Configurare matrice taste
ddrd.5 = 1 : Row1 alias portd.5
ddrd.6 = 1 : Row2 alias portd.6
ddrd.7 = 1 : Row3 alias portd.7
ddrb.1 = 0 : Colon1 alias pinb.1
ddrc.0 = 0 : Colon2 alias pinc.0
ddrc.1 = 0 : Colon3 alias pinc.1

Dim Dummy as Eram Dword                                     'DUMMY memory
Dim Efrecventa as eram word                                 'Frecventa memorata
Dim DP(2) as Byte                                           'Var.puncte clipitoare
Dim a as byte , b as Byte , j as Byte , k as Byte           'Var.de lucru
Dim Text as string * 12                                     'Textul afisat pe display
Dim C(12)as Byte                                            'Var.de conversie pentru VFD controller
Dim CifraCeas(4) as Byte                                    'Cifrele ceasului afisat
Dim Cifra as Byte
Dim RFMF as Boolean                                         'Radio FM Flag
Dim Semnal As Byte
Dim Index As Integer , Index1 As Integer
Dim Isearch As Integer
Dim String_rds As String * 7
Dim Watchdog_timer As Long : Watchdog_timer = 300

Dim Rozeta as Word
Dim ConfigTasteFlags as Word                                'cuvantul care tine FLAGS taste
Dim MenuByte as Byte                                        'variabla meniuri
Dim Minute as Byte , Ore as Byte
Dim Volume as Byte
Dim VolumeTemp as Byte , Evolume as Eram Byte

Dim Frecventa as Word , Frecventa_old as Word               'Frecventa radioului format [1029=102,9MHz]
Dim Frecventa_Str as String * 4
Dim Ar(7) as byte
Dim Control(5) As Byte
Dim Radio as Boolean                                        'Flag care porneste sau opreste radioul
Dim Action as Boolean                                       'Bit care indica schimbarea frecventei de acord
Dim MUTE as Boolean                                         'Bit MUTE radio
Dim Search as byte
Search_stg Alias Search.0
Search_dr Alias Search.1
'VolUP Alias Search.3
'VolDWN Alias Search.4

'Configurare comenzi
Dim ConfigCMD as Byte
PrintF alias ConfigCMD.0                                    'Print On Display Actionive
Roz Alias ConfigCMD.1                                       'Rozetta Actionive
UDvF Alias ConfigCMD.2                                      'Change Volume Actionive
LRmF Alias ConfigCMD.3                                      'Change Menu Actionive
UDmF Alias ConfigCMD.4                                      'Change Minute
UDoF Alias ConfigCMD.5                                      'Change Ore
MANF Alias ConfigCMD.6                                      'MANUAL Mode Seek
SRCF Alias ConfigCMD.7                                      'AUTO Mode seek

'Configurare Flags taste
SOLF alias ConfigTasteFlags.0
STGF alias ConfigTasteFlags.1
DRF alias ConfigTasteFlags.2
ONF Alias ConfigTasteFlags.8
OKF Alias ConfigTasteFlags.4
MENUF Alias ConfigTasteFlags.5
BKF Alias ConfigTasteFlags.6
DWNF Alias ConfigTasteFlags.7
UPF Alias ConfigTasteFlags.3

'Formateaza cifrele
Dim L(10) As Byte
L(0) = &B00111111
L(1) = &B00000110
L(2) = &B01011011
L(3) = &B01001111
L(4) = &B01100110
L(5) = &B01101101
L(6) = &B01111101
L(7) = &B00000111
L(8) = &B01111111
L(9) = &B01101111
L(10) = &B00111111

'declara variabilele de ceas software
Config Clock = User
Dim Secunde as Byte
Dim Takt as Byte

Sub DS1307
        I2cstart                                            'Generate start code
        I2cwbyte I2cwrite                                   'send address
        I2cwbyte 0                                          'start address in 1307
        I2cstart                                            'Generate start code
        I2cwbyte I2cread                                    'send address
        I2crbyte _sec , Ack                                 'Secunde
        I2crbyte _min , Ack                                 'Minute
        I2crbyte _hour , Nack                               'Ore
        I2cstop
  Secunde = Makedec(_sec)
  Minute = Makedec(_min)
  Ore = Makedec(_hour AND &H3F)                             'citeste doar 6 Biti din _hour
End Sub

Sub Change_min
          _min = Makebcd(minute)                            'formateaza minutele
          I2cstart
          I2cwbyte I2cwrite
          I2cwbyte &H0                                      'Modifica secundele
          I2cwbyte 0                                        'la valoarea de zero
          I2cstop
          I2cstart
          I2cwbyte I2cwrite
          I2cwbyte &H1                                      'Modifica minutele
          I2cwbyte _min                                     'la valoarea setata
          I2cstop
End Sub

Sub Change_hour
         _hour = Makebcd(ore)                               'formateaza orele
         I2cstart
         I2cwbyte I2cwrite
         I2cwbyte &H2                                       'Modifica orele
         _hour = _hour OR &H80                              '24h Clock
         I2cwbyte _hour                                     'la valoarea setata
         I2cstop
End Sub

Sub Change_volume
    'Corection volume logarithmic
    If Volume >= 20 then
       VolumeTemp = Volume * 3
    Elseif Volume >= 10 Then
       VolumeTemp = Volume * 2
    Else
       VolumeTemp = Volume
    End if
    'Send to IC-TPC4010A-10K
    I2Cstart
    I2Cwbyte I2Cvolumew
    I2Cwbyte 0
    I2Cwbyte VolumeTemp                                     ' VolumeTemp
    I2Cstop
End Sub

'Rutina de citire RDS data
Sub Radiodatasistem
   Isearch = Frecventa                                      'Search
   'Citeste indexul din tabelul de index
   Index = Lookdown(isearch , Rds_index , 18)               'verifica daca exista rds data
   Index1 = Index - 1                                       'configurare index in baza(0)
   If Index = -1 Then Index1 = 17                           'NO-RDS
   Text = Lookupstr(index1 , Rds_table)
End Sub

$include PT6302driver.INC
$include 4x4_emulate.bas
$include TEA5768.bas
'************************[Init Program]*********************
VFD_init                                                    'init. VFD
VFD_clear                                                   'clear VFD
Waitms 500                                                  'Bitwait
Radio = OFF                                                 'Porneste radio
Volume = Evolume                                            'Preset volume level
If Volume = &HFF then
   Volume = 5
   Evolume = Volume
End if
Change_volume                                               'seteaza volumul
Rozeta = &B01_0101_0101                                     'Preset rozeta dots

'Citeste Frecventa memorata, daca este dummy atunci seteaza default 100,00 MHz
Frecventa = Efrecventa
If Frecventa = &HFFFF then
 Frecventa = 1000
 Efrecventa = Frecventa
End if

Watchdog_timer = 0                                          'Reset Watchdog timer
ConfigCMD = &b1000_0100
'             |     |_Volume Flag Actionivat
'             |__Scan MODE ON

'Porneste ceasul RTC cu secundarul la zero
Init_ceas:
         I2cstart
         I2cwbyte I2cwrite
         I2cwbyte &H07
         I2cwbyte &B10010000
'                   |  |_Auto Reset BAT+ALM flags
'                   |____Enable RTC
         I2Cstop
'***********************************************************
'*                   MAIN PROGRAM                          *
'***********************************************************
Do
                                                        'incrementeaza timerul de program
Incr Watchdog_timer
  Call Read_4x4                                             'Citeste Tastatura
  Call DS1307                                               'Citeste Ceasul RTC

  If Search_stg = ON then
     Decr Frecventa
     MUTE = ON
     If Frecventa < 880 Then Frecventa = 1080
  End If

  If Search_dr = ON Then
     Incr Frecventa
     MUTE = ON
     If Frecventa > 1080 Then Frecventa = 880
  end if

  If RADIO = ON Then                                        'verifica daca a fost pornit RadioFM
        Action = ON
        Call TEA5768                                        'Citeste Radio-FM
        Call RADIODATASISTEM                                'RDS ON
        PrintF = ON                                         'Afiseaza carActionere pe display
  End If
  SW = NOT RADIO                                            'Actioneaza releul de pornire radio
'------------------[ TASTE ]--------------------------------
Tasta_SOL:
  If ConfigTasteFlags <> 1 then goto Tasta_STG
  toggle MUTE
  SOLF = OFF

Tasta_STG:
  If ConfigTasteFlags <> 2 Then goto Tasta_DR
        If Search <> 0 Then
           MANF = ON
           SRCF = OFF
        End if

        If MANF = ON Then
         Search = OFF                                       'anuleaza Searchrea automata
         MUTE = OFF
         If Frecventa > 880 then Decr Frecventa
        End if

        If SRCF = ON then
           Search_stg = ON
        End If

        If LRmF = ON Then
          If MenuByte > 2 Then
             decr MenuByte
          End If
        End if

        Watchdog_timer = 0
        STGF = OFF

Tasta_DR:

        If ConfigTasteFlags <> 4 Then goto Tasta_UP

        If Search <> 0 Then
           MANF = ON
           SRCF = OFF
        End if

       If MANF = ON Then
          Search = OFF
          MUTE = OFF                                        'Anuleaza Searchrea automata
          If Frecventa < 1080 Then Incr Frecventa
       End If

        If SRCF = ON then Search_dr = ON

        If LRmF = ON Then
          If MenuByte < 3 Then
             incr MenuByte
          End If
        End if

        Watchdog_timer = 0
        DRF = OFF

Tasta_UP:
  If ConfigTasteFlags <> 8 Then goto Tasta_DWN

    If MenuByte = 2 OR MenuByte = 3 Then goto Label1
       MenuByte = 4
       Watchdog_timer = 0
       If Volume < 42 Then incr Volume
       Change_volume
       Rozeta = NOT Rozeta
       waitms 50
Label1:
       If UDmF = ON then                                    'reglaj minute Actionivat
          incr Minute
          If Minute > 59 Then Minute = 0
          Change_min                                        'regleaza minute
       End if

       If UDoF = ON then
          incr Ore
          If Ore > 23 Then Ore = 0
          Change_hour
       End if
        Watchdog_timer = 0
       UPF = OFF

Tasta_DWN:
  If ConfigTasteFlags <> 128 then goto Tasta_OK
       If MenuByte = 2 OR MenuByte = 3 Then goto Label2
          MenuByte = 4
          Watchdog_timer = 0
          If Volume > 0 Then decr Volume
          Change_volume
          Toggle rozeta
          waitms 50
Label2:
       If UDmF = ON then                                    'Reglaj Minute
          decr Minute
          If Minute = 255 Then Minute = 59
          Change_min
       End if

       If UDoF = ON Then
          Decr Ore
          If Ore = 255 then ore = 23
          Change_hour
       End if
        Watchdog_timer = 0
        DWNF = OFF

Tasta_OK:
  If ConfigTasteFlags <> 16 Then Goto Tasta_MENU
      MenuByte = 0
      ConfigCMD = &B1000_0100
'                   |     |_Volume Flag Active
'                   |_Auto Search Flag Active
      VFD_clear
      Search = OFF
      OKF = OFF

Tasta_MENU:
  If ConfigTasteFlags <> 32 then goto Tasta_BK
       MenuByte = 1
       Watchdog_timer = 0
       MENUF = OFF
       UDvF = OFF

Tasta_BK:
  if ConfigTasteFlags <> 64 then goto Tasta_ON
       Watchdog_timer = 0
       BKF = OFF

Tasta_ON:
  if ConfigTasteFlags <> 256 then goto Afisare
       Toggle Radio                                         'Porneste sau Opreste Radio
       MenuByte = 0
       ConfigCMD = &B1100_0000
'                    ||_MANUAL Search Flag  Active
'                    |_AUTO Search Flag Active
       Watchdog_timer = 0
       VFD_clear
       ONF = OFF

'------------[ Afisare text pe display ]--------------------
Afisare:

    Select Case MenuByte
       Case 1:
         Text = "Clock <Adj> "
         ConfigCMD = 0 OR &B0000_1001
'                                |  |_Print Flag Active
'                                |_LRmF (menu left/right) Active
       Case 2:
         Text = "Minut Up/Dwn"
         ConfigCMD = 0 OR &B0001_1001
'                              | |  |_Print Flag Active
'                              | |_LRmF (menu left/right) Active
'                              |_Change Minute Flag Active
       Case 3:
         Text = "Hours Up/Dwn"
         ConfigCMD = 0 OR &B0010_1001
'                             |  |  |_Print Flag Active
'                             |  |_LRmF (menu left/right)
'                             |____Change Hours Flag Actionive
       Case 4:
        Text = "VOLUM Up/Dwn"
        ConfigCMD = 0 OR &B0000_0101
'                                | |_Print Flag Active
'                                |_UDvF=ON (up/down volume flag)
    End Select

Print_on_VFD:
    If PrintF = ON Then
       Call Sent2Display(Text)                              'print Text on Display
       PrintF = OFF
    End if
'***********************************************************
     CifraCeas(4) = Minute Mod 10                           'Minute
     If CifraCeas(4) = 0 then CifraCeas(4) = 10
     CifraCeas(3) = Minute / 10                             'Zeci de minute
     If CifraCeas(3) = 0 then CifraCeas(3) = 10
     CifraCeas(2) = Ore Mod 10                              'Ore
     If CifraCeas(2) = 0 then CifraCeas(2) = 10
     CifraCeas(1) = Ore / 10                                'Zeci de ore

'Conversie cifre in carActionere pe VFD(1) --------------------
'                  _DP(1)=ON; DP(2)=ON
'                 |
'           1 8 8 : 8 8
'           | | |   | |_C(5)= Minute
'           | | |   |___C(4)= Zeci de Minute
'           | | |_______C(3)= Ore
'           | |_________C(2)= Zeci de Ore
'           |___________C(1)=0 (stinge cifra)
C(1) = 0
C(2) = L(CifraCeas(1))
 If Ore < 10 Then C(2) = 0
C(3) = L(CifraCeas(2))
C(4) = L(CifraCeas(3))
C(5) = L(CifraCeas(4))
Takt = Secunde MOD 2
DP(1) = Takt : DP(2) = Takt

If Radio = OFF then
   FM_ind = OFF
   Call DigitsGroup(2)                                      'Trimite informatia spre Grup Digits Stg (1)
Else
   Call DigitsGroup(1)
end if
'-----------------------
LedV = Radio
LedR = NOT LedV
If Radio = OFF then goto Fine                               'daca Radio=Off nu afisa informatii inutile
'Debuging
Frecventa_Str = Str(Frecventa)                              'Converteste frecventa in String
str2digits Frecventa_Str , Ar(1)                            'Descompune frecventa in cifre separate
     CifraCeas(4) = Ar(5)                                   'Frecventa Mii
     If CifraCeas(4) = 0 then CifraCeas(4) = 10

     CifraCeas(3) = Ar(4)                                   'Frecventa Sute
     If CifraCeas(3) = 0 then CifraCeas(3) = 10

     CifraCeas(2) = Ar(3)                                   'Frecventa Unitati
     If CifraCeas(2) = 0 then CifraCeas(2) = 10

     CifraCeas(1) = Ar(2)                                   'Frecventa Zecimala
     If CifraCeas(1) = 0 then CifraCeas(1) = 10

'Conversie cifre in carActionere pe VFD(2) --------------------
'                  _DP(1)=OFF; DP(2)=ON
'                 |
'           1 8 8 : 8 8
'           | | |   | |_C(5)=0
'           | | |   |___C(4)= L(CifraCeas(1))
'           | | |_______C(3)= L(CifraCeas(2))
'           | |_________C(2)= L(CifraCeas(3))
'           |___________C(1)= L(CifraCeas(4))

C(1) = L(CifraCeas(4))
If Frecventa < 1000 Then C(1) = 0                           'stinge cifra C(1) daca frecventa este sub 1000
C(2) = L(CifraCeas(3))
C(3) = L(CifraCeas(2))
C(4) = L(CifraCeas(1))
C(5) = L(10)
DP(1) = OFF                                                 'Stinge pct de sus
DP(2) = ON                                                  'Aprinde pct in loc de virgula
FM_ind = ON                                                 'Arata indicator FM pe VFD
Call DigitsGroup(2)                                         'Trimite info la VFD Grup Afisaj mijloc (2)

'Sterge carActionerele inutile din Grup VFD (3)----------------
C(1) = 0                                                    'Stinge informatii inutile de pe afisaj
C(2) = 0                                                    'Stinge informatii inutile de pe afisaj
C(3) = 0                                                    'Stinge informatii inutile de pe afisaj

CifraCeas(1) = Volume Mod 10
If CifraCeas(1) = 0 Then CifraCeas(1) = 10

CifraCeas(2) = Volume / 10
If CifraCeas(2) = 0 Then CifraCeas(2) = 10

C(4) = L(Cifraceas(1))
C(5) = L(CifraCeas(2))

If LRmF = ON then Title_AM_CEAS_ind = ON

    If Index1 <> 17 Then
      ANT_ind = ON
      MUTE = OFF
      If Watchdog_timer > 0 then Search = OFF
    End If

Roz = ON                                                    'Actionare Efect Rozeta
DP(2) = OFF                                                 'Stinge pct

Call DigitsGroup(3)                                         'Trimite info la VFD Display3
'-----------------------
Title_AM_CEAS_ind = OFF
ANT_ind = OFF
Reset Roz                                                   'anuleaza afisarea rozetei pt.Display1,Display2
CH_R7_ind = OFF                                             'Stinge informatii inutile de pe afisaj
'memoreaza noile situatii create
   If Watchdog_timer = 20 Then
Random_save:
    If Frecventa_old <> frecventa Then                      'Daca frecventa e modificata
     Frecventa_old = Frecventa                              'Salveaza frecventa temporar
     Efrecventa = Frecventa                                 'Memoreaza frecventa in EEprom
    End if
    Evolume = Volume                                        'Memoreaza volumul
    Toggle rozeta                                           'Roteste rozeta
    PrintF = ON
Fine:
    If MenuByte <> 0 OR MANF = ON Then OKF = ON             'daca nu se mai apasa nicio tasta...
   End If

Loop
End
'Radio Data Sistem encoding info
Rds_table:
Data " RADIO GAGA " , "  ROCK-FM   " , "   DIGI-FM  " , "   KISS-FM  " , " EUROPA-FM  " , "  RADIO SON "
Data "  RADIO-21  " , "R.R.ACTUALIT" , "  DANCE-FM  " , "  RADIO-ZU  " , "REINTREGIREA" , "  ATLAS-FM  "
Data "NATIONAL FM " , "  MAGIC-FM  " , "   PRO-FM   " , " TARGU-MURES" , "R.R.CULTURAL" , "   NO-RDS   "
'Radio Data Sistem info frecvente
Rds_index:
Data 880% , 884% , 891% , 903% , 907% , 1056%
Data 927% , 936% , 1000% , 980% , 986% , 1064%
Data 1006% , 1012% , 1016% , 1029% , 1049% , 1000%